/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package xyz.matj1.bp;

import mcdr.sequence.SequenceMotionWords;
import mcdr.sequence.impl.SequenceMotionWordsDTW;
import mcdr.test.utils.ObjectCategoryMgmt;
import mcdr.test.utils.ObjectMgmt;
import xyz.matj1.bp.Utils.LengthRelation;

import java.io.File;
import java.io.IOException;

/**
 * @author Matěj Bagar
 */
public class BPBagar2 {
	/**
	 * The method in which other methods run.
	 *
	 * @param args the command line arguments (ignored)
	 */
	public static void main(String[] args) throws IOException {
		/************** Working with MW data (hard MWs) *********************/
		var mwSequenceMgmt = loadData("data/hdm05-annotations_specific-segment80_shift16-coords_normPOS-fps12-quantized-pivots-kmedoids-350.data");

		File differenceGraphsDir = new File("difference graphs");
		LengthTesting.pairwiseCorrelationShow(mwSequenceMgmt, LengthRelation.DIFFERENCE, differenceGraphsDir);

		File quotientGraphsDir = new File("quotient graphs");
		LengthTesting.pairwiseCorrelationShow(mwSequenceMgmt, LengthRelation.QUOTIENT, quotientGraphsDir);

		System.exit(0);

		BasicTasks.tasks(mwSequenceMgmt);
	}

	/**
	 * Loads data for testing motion words from the file at the given path.
	 *
	 * @param path the given path
	 * @return an object with motion sequences and their categories
	 * @throws IOException
	 */
	private static ObjectMgmt loadData(String path) throws IOException {
		final Class<? extends SequenceMotionWords<?>> mwClass = SequenceMotionWordsDTW.class;
		ObjectCategoryMgmt mwCategoryMgmt = new ObjectCategoryMgmt();
		ObjectMgmt mwSequenceMgmt = new ObjectMgmt(mwCategoryMgmt);
		mwSequenceMgmt.read(mwClass, path);

		return mwSequenceMgmt;
	}
}

